
/* split.c. Program to split absolute output into even and odd address ROMS */

#include <stdio.h>
#include <mem.h>
#include <fcntl.h>
#include <string.h>

  typedef unsigned char byte;

  byte  IOBuffer[4096], evenbuffer[8192], oddbuffer[8192];

  int       BinFileIn;
  int       OddFileOut;
  int       EvenFileOut;

  unsigned  long total_bytes;
  unsigned  long rom_size;
  int       bytes_read, iob;

void main(int argc, char *argv[])
{
register int  i, j, k;

  if (argc < 4) 
     {
     printf("Usage: split infile evenfile oddfile\n");
     exit(1);
     }

  if ((BinFileIn = open(argv[1],O_BINARY | O_RDONLY)) < 0) 
     {
     printf("Couldn't open %s \n",argv[1]);
     exit(1);
     }

  if ((EvenFileOut = _creat(argv[2],0)) < 0 ) 
     {
     printf("Couldn't open even file for rewriting\n",argv[1]);
     exit(1);
     }

  if ((OddFileOut = _creat(argv[3],0)) < 0 )
     {
     printf("Couldn't open odd file for rewriting\n",argv[1]);
     exit(1);
     }

  rom_size = 16384;
  total_bytes = 0;
  iob = sizeof(IOBuffer);
  j=k=0;

  do
    {
    if (!eof(BinFileIn))
       bytes_read = read(BinFileIn,IOBuffer,iob);
    else
       bytes_read = 0;

    for (i=0; i<bytes_read; i+=2)
	evenbuffer[j++] = IOBuffer[i];

    for (i=1; i<bytes_read; i+=2)
	oddbuffer[k++] = IOBuffer[i];
    total_bytes += bytes_read;
    }
  while (total_bytes != rom_size);

  write(OddFileOut,oddbuffer,8192);
  write(EvenFileOut,evenbuffer,8192);

  close(BinFileIn);
  close(OddFileOut);
  close(EvenFileOut);
}
